## Programa 2024-2025

### Clases presenciales

* Martes 9:00 a 11:00, 210 Laboratorios III
* Jueves 11:00 a 13:00, 203 Laboratorios III

### Sesiones

28 sesiones en total:

| Martes | Tema                         | Jueves | Tema                            |
|--------|------------------------------|--------|---------------------------------|
| Sep 10 | Presentación, Introducción   | Sep 12 | Introducción                    |
| Sep 17 | Introducción                 | Sep 19 | Introducción                    |
| Sep 24 | Entorno                      | Sep 26 | Entorno                         |
| Oct 1  | Entorno, Estructuras control | Oct 3  | Entorno, Estructuras de control |
| Oct 8  | NO LECTIVO                   | Oct 10 | Divide y vencerás               |
| Oct 15 | Estructuras de control       | Oct 17 | Divide y vencerás               |
| Oct 22 | Divide y vencerás            | Oct 24 | Algoritmos I                    |
| Oct 29 | Divide y vencerás            | Oct 31 | Algoritmos I                    |
| Nov 5  | Estructuras datos I          | Nov 7  | Algoritmos II                   |
| Nov 12 | Estructuras datos I          | Nov 14 | Algoritmos II                   |
| Nov 19 | Estructuras datos II         | Nov 21 | Proyecto final                  |
| Nov 26 | Estructuras datos II         | Nov 28 | Algoritmos III                  |
| Dic 3  | Gestión de Ficheros          | Dic 5  | NO LECTIVO                      |
| Dic 10 | Orientación objetos          | Dic 12 | Algoritmos III                  |
| Dic 17 | Eficiencia                   | Dic 19 | Proyecto final                  |

* [Temario de Frikiminutos](../frikiminutos/README.md)

### Programa

* Presentación de la asignatura
  * Objetivos
  * Métodos
  * Programa
  * Evaluación
* [Introducción a la programación y la informática](00-intro/README.md):
  * Programación con `turtle`
  * Motivación
  * Instrucciones
  * Variables
  * Expresiones
* [El entorno de programación](01-entorno/README.md):
  * El IDE (Integrated Development Environment): PyCharm
  * El entorno Linux del laboratorio
  * Introducción a la shell (intérprete de comandos)
  * Depuración (debugging)
  * Sistemas de control de versiones: Git
  * Servicios de apoyo al desarrollo: GitLab
* [Estructuras de control](02-control/README.md):
  * Secuencia
  * Condiciones (if-elif-else)
  * Bucles (for, while)
  * Excepciones (try, except)
  * Pruebas (testing) y aserciones (assertions)
* [Divide y vencerás](03-divide/README.md):
  * Funciones
  * Ámbitos de las variables
  * Instalación de paquetes Python: pip
* Estructuras de datos I:
  * Listas
  * Tuplas
* [Algoritmos I]():
  * Ordenación
  * Manipulación de cadenas
  * Aproximaciones
  * Búsqueda binaria
* Estructuras de datos II:
  * diccionarios
  * combinación de estructuras
  * punteros y gestión de memoria
* [Algoritmos II]():
  * Ordenación
  * Aproximación
* Gestión de ficheros
* Programación orientada a objectos
  * Clases y objetos (instanciación de clases)
  * Herencia
* [Algoritmos III]():
  * Búsqueda
* Eficiencia:
  * Complejidad
  * Tipos de complejidad
  * Complejidad para algunos algoritmos
* [Proyecto final]()
